# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free
%define oname bsf
%define named_version 3.0-beta2

Name:           bsf3
Version:        3.0
Release:        0.b2.1%{dist}
Epoch:          0
Summary:        Bean Scripting Framework
License:        Apache License 2.0
Url:            http://jakarta.apache.org/bsf/
Group:          Development/Libraries/Java
Source0:        bsf-3.0-beta2-src.tar.gz
Source1:        empty.zip
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml
#Source4:        axiom-e4x-0.29.jar
Patch0:         bsf3-engines-build.patch
Patch1:         bsf3-distribution-build.patch
Patch2:         bsf3-testing-e4x-pom.patch
Patch3:         bsf3-testing-e4x-1.6R7-pom.patch
Patch4:         bsf3-no-java-engine.patch

BuildRequires:  jpackage-utils >= 1.7.5
BuildRequires:  java-devel >= 1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-plugin

BuildRequires:  asm2
BuildRequires:  axiom-e4x
BuildRequires:  jakarta-commons-collections >= 0:3.1
BuildRequires:  jakarta-commons-logging >= 0:1.0.4
BuildRequires:  jdom >= 0:1.0
BuildRequires:  jsr223-scripting-engines
#BuildRequires:  jsr223-scripting-engines-browserjs
BuildRequires:  jsr223-scripting-engines-bsh
BuildRequires:  jsr223-scripting-engines-freemarker
BuildRequires:  jsr223-scripting-engines-groovy
BuildRequires:  jsr223-scripting-engines-jacl
BuildRequires:  jsr223-scripting-engines-jaskell
#BuildRequires:  jsr223-scripting-engines-java
BuildRequires:  jsr223-scripting-engines-jawk
BuildRequires:  jsr223-scripting-engines-jelly
BuildRequires:  jsr223-scripting-engines-jep
BuildRequires:  jsr223-scripting-engines-jexl
BuildRequires:  jsr223-scripting-engines-jruby
BuildRequires:  jsr223-scripting-engines-js
BuildRequires:  jsr223-scripting-engines-judo
BuildRequires:  jsr223-scripting-engines-juel
BuildRequires:  jsr223-scripting-engines-jython
BuildRequires:  jsr223-scripting-engines-ognl
BuildRequires:  jsr223-scripting-engines-pnuts
BuildRequires:  jsr223-scripting-engines-scheme
BuildRequires:  jsr223-scripting-engines-velocity
BuildRequires:  jsr223-scripting-engines-xpath
BuildRequires:  jsr223-scripting-engines-xslt
BuildRequires:  junit >= 0:3.8.2
BuildRequires:  log4j >= 0:1.2.12
BuildRequires:  retroweaver
BuildRequires:  stax_1_0_api
BuildRequires:  velocity >= 0:1.4
BuildRequires:  ws-commons-axiom
BuildRequires:  wstx
BuildRequires:  xalan-j2 >= 0:2.7.0
BuildRequires:  xerces-j2 >= 0:2.7.0
#
BuildRequires:  bsh
BuildRequires:  groovy
BuildRequires:  jython
BuildRequires:  jruby
BuildRequires:  rhino

Requires:  java >= 0:1.5.0
Requires:  jakarta-commons-collections >= 0:3.1
Requires:  jakarta-commons-logging >= 0:1.0.4
Requires:  jdom >= 0:1.0
Requires:  log4j >= 0:1.2.12
Requires:  velocity >= 0:1.4
Requires:  xalan-j2 >= 0:2.7.0
Requires:  xerces-j2 >= 0:2.7.0

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%if ! %{gcj_support}
BuildArch:      noarch
%endif

BuildRoot:       %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
Bean Scripting Framework (BSF) is a set of Java classes which provides
scripting language support within Java applications, and access to Java
objects and methods from scripting languages. BSF allows one to write
JSPs in languages other than Java while providing access to the Java
class library. In addition, BSF permits any Java application to be
implemented in part (or dynamically extended) by a language that is
embedded within it. This is achieved by providing an API that permits
calling scripting language engines from within Java, as well as an
object registry that exposes Java objects to these scripting language
engines.

BSF supports several scripting languages currently:
* Javascript (using Rhino ECMAScript, from the Mozilla project)
* Python (using either Jython or JPython)
* Tcl (using Jacl)
* NetRexx (an extension of the IBM REXX scripting language in Java)
* XSLT Stylesheets (as a component of Apache XML project's Xalan and
Xerces)

In addition, the following languages are supported with their own BSF
engines:
* Java (using BeanShell, from the BeanShell project)
* JRuby
* JudoScript

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{oname}-%{named_version}-src
# remove all binary libs
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4

for p in $(find . -name build.xml -o -name pom.xml); do
	sed -i -e 's/-beta2//' $p
done
mkdir -p bsf-engines/target/engines-download/
pushd bsf-engines/target/engines-download/
#touch engines.zip
cp %{SOURCE1} engines.zip
mkdir -p engines/beanshell/build/
ln -sf $(build-classpath scripting-engines/bsh-engine) engines/beanshell/build/
mkdir -p engines/browserjs/build/
ln -sf $(build-classpath scripting-engines/browserjs-engine) engines/browserjs/build/
mkdir -p engines/freemarker/build/
ln -sf $(build-classpath scripting-engines/freemarker-engine) engines/freemarker/build/
mkdir -p engines/groovy/build/
ln -sf $(build-classpath scripting-engines/groovy-engine) engines/groovy/build/
mkdir -p engines/jacl/build/
ln -sf $(build-classpath scripting-engines/jacl-engine) engines/jacl/build/
mkdir -p engines/jaskell/build/
ln -sf $(build-classpath scripting-engines/jaskell-engine) engines/jaskell/build/
#mkdir -p engines/java/build/
#ln -sf $(build-classpath scripting-engines/java-engine) engines/java/build/
mkdir -p engines/javascript/build/
ln -sf $(build-classpath scripting-engines/js-engine) engines/javascript/build/
mkdir -p engines/jawk/build/
ln -sf $(build-classpath scripting-engines/jawk-engine) engines/jawk/build/
mkdir -p engines/jelly/build/
ln -sf $(build-classpath scripting-engines/jelly-engine) engines/jelly/build/
mkdir -p engines/jep/build/
ln -sf $(build-classpath scripting-engines/jep-engine) engines/jep/build/
mkdir -p engines/jexl/build/
ln -sf $(build-classpath scripting-engines/jexl-engine) engines/jexl/build/
mkdir -p engines/jruby/build/
ln -sf $(build-classpath scripting-engines/jruby-engine) engines/jruby/build/
mkdir -p engines/judo/build/
ln -sf $(build-classpath scripting-engines/judo-engine) engines/judo/build/
mkdir -p engines/juel/build/
ln -sf $(build-classpath scripting-engines/juel-engine) engines/juel/build/
mkdir -p engines/jython/build/
ln -sf $(build-classpath scripting-engines/jython-engine) engines/jython/build/
mkdir -p engines/ognl/build/
ln -sf $(build-classpath scripting-engines/ognl-engine) engines/ognl/build/
mkdir -p engines/pnuts/build/
ln -sf $(build-classpath scripting-engines/pnuts-jsr223) engines/pnuts/build/
mkdir -p engines/scheme/build/
ln -sf $(build-classpath scripting-engines/scheme-engine) engines/scheme/build/
mkdir -p engines/velocity/build/
ln -sf $(build-classpath scripting-engines/velocity-engine) engines/velocity/build/
mkdir -p engines/xpath/build/
ln -sf $(build-classpath scripting-engines/xpath-engine) engines/xpath/build/
mkdir -p engines/xslt/build/
ln -sf $(build-classpath scripting-engines/xslt-engine) engines/xslt/build/
popd


%build
cp %{SOURCE3} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export JAVA_HOME=%{_jvmdir}/java-1.5.0

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/org.apache.bsf/
ln -sf bsf-engines/target/bsf-engines-3.0.jar $MAVEN_REPO_LOCAL/org.apache.bsf/bsf-engines.jar

mkdir -p $MAVEN_REPO_LOCAL
ln -sf $(build-classpath retroweaver) $MAVEN_REPO_LOCAL
ln -sf $(build-classpath retroweaver-rt) $MAVEN_REPO_LOCAL
ln -sf $(build-classpath objectweb-asm/asm-all) $MAVEN_REPO_LOCAL
ln -sf $(build-classpath backport-util-concurrent) $MAVEN_REPO_LOCAL

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.suffix="-jpp" \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install 

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.suffix="-jpp" \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        javadoc:javadoc

%install
%{__rm} -fr %{buildroot}
%{__install} -d -m 755 %{buildroot}%{_datadir}/maven2/poms

# jar
%{__install} -d -m 755 %{buildroot}%{_javadir}/%{name}

%{__install} -m 644 pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3-parent.pom
%add_to_maven_depmap org.apache.bsf parent %{named_version} JPP/%{name} parent

%{__install} -m 644 bsf-api/target/%{oname}-api-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/api-%{version}.jar
%{__install} -m 644 bsf-api/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3-api.pom
%add_to_maven_depmap org.apache.bsf bsf-api %{named_version} JPP/%{name} api

%{__install} -m 644 bsf-engines/target/%{oname}-engines-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/engines-%{version}.jar
%{__install} -m 644 bsf-engines/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3-engines.pom
%add_to_maven_depmap org.apache.bsf bsf-engines %{named_version} JPP/%{name} engines

%{__install} -m 644 bsf-utils/target/%{oname}-utils-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/utils-%{version}.jar
%{__install} -m 644 bsf-utils/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3-utils.pom
%add_to_maven_depmap org.apache.bsf bsf-utils %{named_version} JPP/%{name} utils

%{__install} -m 644 distribution/target/%{oname}-all-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/all-%{version}.jar
%{__install} -m 644 distribution/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3-all.pom
%add_to_maven_depmap org.apache.bsf bsf-all %{named_version} JPP/%{name} all

(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

%{__install} -d -m 755 %{buildroot}%{_javadir}/%{name}/testing

%{__install} -m 644 testing/e4x-1.6R7-Axiom/target/%{oname}-testing-e4x-1.6R7-Axiom-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/testing/e4x-1.6R7-Axiom-%{version}.jar
%{__install} -m 644 testing/e4x-1.6R7-Axiom/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3.testing-e4x-1.6R7-Axiom.pom
%add_to_maven_depmap org.apache.bsf.testing bsf-testing-e4x-1.6R7-Axiom %{named_version} JPP/%{name}/testing e4x-1.6R7-Axiom

%{__install} -m 644 testing/e4x/target/%{oname}-testing-e4x-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/testing/e4x-%{version}.jar
%{__install} -m 644 testing/e4x/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3.testing-e4x.pom
%add_to_maven_depmap org.apache.bsf.testing bsf-testing-e4x %{named_version} JPP/%{name}/testing e4x

%{__install} -m 644 testing/groovy-1.1/target/%{oname}-testing-groovy-1.1-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/testing/groovy-1.1-%{version}.jar
%{__install} -m 644 testing/groovy-1.1/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3.testing-groovy-1.1.pom
%add_to_maven_depmap org.apache.bsf.testing bsf-testing-groovy-1.1 %{named_version} JPP/%{name}/testing groovy-1.1

%{__install} -m 644 testing/groovy/target/%{oname}-testing-groovy-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/testing/groovy-%{version}.jar
%{__install} -m 644 testing/groovy/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3.testing-groovy.pom
%add_to_maven_depmap org.apache.bsf.testing bsf-testing-groovy %{named_version} JPP/%{name}/testing groovy

%{__install} -m 644 testing/javascript/target/%{oname}-testing-javascript-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/testing/javascript-%{version}.jar
%{__install} -m 644 testing/javascript/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3.testing-javascript.pom
%add_to_maven_depmap org.apache.bsf.testing bsf-testing-javascript %{named_version} JPP/%{name}/testing javascript

%{__install} -m 644 testing/jython-2.2/target/%{oname}-testing-jython-2.2-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/testing/jython-2.2-%{version}.jar
%{__install} -m 644 testing/jython-2.2/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3.testing-jython-2.2.pom
%add_to_maven_depmap org.apache.bsf.testing bsf-testing-jython-2.2 %{named_version} JPP/%{name}/testing jython-2.2

%{__install} -m 644 testing/python/target/%{oname}-testing-python-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/testing/python-%{version}.jar
%{__install} -m 644 testing/python/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3.testing-python.pom
%add_to_maven_depmap org.apache.bsf.testing bsf-testing-python %{named_version} JPP/%{name}/testing python

%{__install} -m 644 testing/ruby/target/%{oname}-testing-ruby-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/testing/ruby-%{version}.jar
%{__install} -m 644 testing/ruby/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3.testing-ruby.pom
%add_to_maven_depmap org.apache.bsf.testing bsf-testing-ruby %{named_version} JPP/%{name}/testing ruby

(cd %{buildroot}%{_javadir}/%{name}/testing && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

%{__install} -m 644 testing/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.bsf3-testing.pom
%add_to_maven_depmap org.apache.bsf bsf-tests %{named_version} JPP/%{name} testing


# javadoc
%{__install} -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
(cd %{buildroot}%{_javadocdir} && ln -sf %{name}-%{version} %{name})

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root)
%doc LICENSE
%{_javadir}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root)
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/*
%{_javadocdir}/%{name}

%changelog
* Tue Oct 07 2008 Ralph Apel <r.apel at r-apel.de> 0:3.0-0.b2.1.jpp5
- 3.0 as bsf3

* Thu Jul 12 2007 Ralph Apel <r.apel at r-apel.de> 0:2.4.0-1jpp
- Upgrade to 2.4.0
- Add manual and demo subpackages
- Add pom and depmap frag
- Activate bsh jruby jython rhino optionals

* Thu Aug 03 2006 Deepak Bhole <dbhole@redhat.com> 0:2.3.0-11jpp
- Added missing requirements.

* Thu Jul 20 2006 Deepak Bhole <dbhole@redhat.com> 0:2.3.0-10jpp
- Added conditional native compilation.

* Wed Apr 26 2006 Fernando Nasser <fnasser@redhat.com>  0:2.3.0-9jpp
- First JPP 1.7 build

* Wed Nov 3 2004 Nicolas Mailhot <nim@jpackage.org>  0:2.3.0-8jpp
- Clean up specfile a bit

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> 0:2.3.0-7jpp
- Build with ant-1.6.2

* Thu Oct 09 2003 David Walluck <david@anti-microsoft.org> 0:2.3.0-6jpp
- add javadoc symlinks
- change Apache Software License to Apache License

* Tue Aug 26 2003 David Walluck <david@anti-microsoft.org> 0:2.3.0-5jpp
- remove all Requires

* Fri Apr 12 2003 David Walluck <david@anti-microsoft.org> 0:2.3.0-4jpp
- fix strange permissions

* Fri Apr 11 2003 David Walluck <david@anti-microsoft.org> 0:2.3.0-3jpp
- rebuild for jpackage 1.5

* Wed Jan 22 2003 David Walluck <david@anti-microsoft.org> 2.3.0-2jpp
- Requires/BuildRequires: xalan-j2
- update %%description

* Mon Jan 13 2003 David Walluck <david@anti-microsoft.org> 2.3.0-1jpp
- version 2.3.0 (first jakarta release)

* Tue May 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2-5jpp 
- vendor, distribution, group tags
- versioned dir for javadoc
- section macro

* Sat Dec 1 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2-4jpp
- javadoc in javadoc package

* Wed Nov 21 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 2.2-3jpp
- removed packager tag
- new jpp extension
- fixed url

* Sat Oct 6 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2-2jpp
- first unified release
- used original tarball
- s/jPackage/JPackage

* Thu Aug 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2-1jpp
- first Mandrake release
